// **********************************************************************
//
// Copyright (c) 2003-2005 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

public class Client {
    public static void
    main(String[] args)
    {
        int status = 0;
        Ice.Communicator ic = null;
        try {
	    ic = Ice.Util.initialize(args);
	    Ice.ObjectPrx base = ic.stringToProxy(
		    "SimplePrinter:default -p 10000");
	    Demo.PrinterPrx printer = Demo.PrinterPrxHelper.checkedCast(base);
	    if (printer == null)
	        throw new Error("Invalid proxy");

	    printer.printString("Hello World!");
        } catch (Ice.LocalException e) {
            e.printStackTrace();
	    status = 1;
        } catch (Exception e) {
	    System.err.println(e.getMessage());
	    status = 1;
	}
	if (ic != null) {
	    // Clean up
	    //
	    try {
		ic.destroy();
	    } catch (Exception e) {
		System.err.println(e.getMessage());
		status = 1;
	    }
	}
        System.exit(status);
    }
}
